﻿using System;
using System.Web;
using System.Web.UI;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.Owin;
using Owin;
using ASPNETWebFormsIdentity.Models;

namespace ASPNETWebFormsIdentity.Account
{
    public partial class Login : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            RegisterHyperLink.NavigateUrl = "Register";
            // パスワードの再設定機能についてアカウントの確認を有効にしてから、この設定を有効にしてください
            // ForgotPasswordHyperLink.NavigateUrl = "Forgot";
            OpenAuthLogin.ReturnUrl = Request.QueryString["ReturnUrl"];
            var returnUrl = HttpUtility.UrlEncode(Request.QueryString["ReturnUrl"]);
            if (!String.IsNullOrEmpty(returnUrl))
            {
                RegisterHyperLink.NavigateUrl += "?ReturnUrl=" + returnUrl;
            }
        }

        protected void LogIn(object sender, EventArgs e)
        {
            if (IsValid)
            {
                // ユーザーのパスワードを検証します
                var manager = Context.GetOwinContext().GetUserManager<ApplicationUserManager>();
                ApplicationUser user = manager.Find(Email.Text, Password.Text);
                if (user != null)
                {
                    //（ISY01）ログインの際にメール確認を条件にする
                    if (!user.EmailConfirmed)
                    {
                        FailureText.Text = "メールで認証を行ってください。";
                        ErrorMessage.Visible = true;
                        return;
                    }

                    // (ISY05)ユーザロック
                    if (manager.IsLockedOut(user.Id))
                    {
                        FailureText.Text = "ユーザーがロックされました。しばらくしてからアクセスして下さい。";
                        ErrorMessage.Visible = true;
                        return;
                    }

                    // (ISY05)パスワードが正しい場合はリトライをクリア
                    manager.ResetAccessFailedCount(user.Id);

                    //通常のログイン
                    IdentityHelper.SignIn(manager, user, RememberMe.Checked);
                    IdentityHelper.RedirectToReturnUrl(Request.QueryString["ReturnUrl"], Response);
                }
                else
                {
                    //(ISY05)ユーザは存在するかどうか
                    user = manager.FindByName(Email.Text);

                    //ユーザが存在しない場合
                    FailureText.Text = "ユーザー名またはパスワードが無効です。";
                    ErrorMessage.Visible = true;
                    
                    if (user == null)
                    {
                        return;
                    }
                    //パスワードが違う場合
                    else
                    {
                        manager.SetLockoutEnabled(user.Id, true); //ロックを可にしておく
                        manager.AccessFailed(user.Id); //ログイン出来ない

                        //(ISY05)これでリトライカウントが取得できる（ここでは未使用）
                        //int cnt = user.AccessFailedCount;
                   
                        if (manager.IsLockedOut(user.Id))
                        {
                            FailureText.Text = "ユーザーがロックされました。しばらくしてからアクセスして下さい。";
                        }
                    }
                }
            }
        }
    }
}