﻿using System;
using System.Linq;
using System.Web;
using System.Web.UI;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.Owin;
using Owin;
using ASPNETWebFormsIdentity.Models;

namespace ASPNETWebFormsIdentity.Account
{
    public partial class Register : Page
    {
        protected void CreateUser_Click(object sender, EventArgs e)
        {
            var manager = Context.GetOwinContext().GetUserManager<ApplicationUserManager>();

            //(ISY02)表示名の登録
            //var user = new ApplicationUser() { UserName = Email.Text, Email = Email.Text };
            var user = new ApplicationUser() { UserName = Email.Text, Email = Email.Text, DispName = DispName.Text };

            IdentityResult result = manager.Create(user, Password.Text);
            if (result.Succeeded)
            {
                //（ISY01）ここでサインイン（ログイン）はしない
                //IdentityHelper.SignIn(manager, user, isPersistent: false);

                // アカウントの確認とパスワードの再設定を有効にする方法については、http://go.microsoft.com/fwlink/?LinkID=320771 を参照してください
                string code = manager.GenerateEmailConfirmationToken(user.Id);
                string callbackUrl = IdentityHelper.GetUserConfirmationRedirectUrl(code, user.Id);

                //（ISY01）URL作成
                string domainName = Request.Url.GetLeftPart(UriPartial.Authority) + Request.ApplicationPath;
                string url = domainName + callbackUrl;

                //（ISY01）HTMLテキストの作成
                string linktext = "このリンクをクリックすることによってアカウントを確認してください。  " + url;

                //manager.SendEmail(user.Id, "アカウントの確認", "このリンクをクリックすることによってアカウントを確認してください <a href=\"" + callbackUrl + "\">こちら</a>.");
                manager.SendEmail(user.Id, "アカウントの確認", linktext);

                //（ISY01）リダイレクトしないでメッセージを表示
                lblConfirm.Visible = true;
                //IdentityHelper.RedirectToReturnUrl(Request.QueryString["ReturnUrl"], Response);
            }
            else
            {
                ErrorMessage.Text = result.Errors.FirstOrDefault();
            }
        }
    }
}